#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-
"""
Name: hddata_conky2_CB10_lua.py
Author: arclance
Date_Created:2011-11
Date_Updated:2012-08-03

python script to check hard drive data by uuid for output in conky
v2.2 2012-08-13
	change ouput so list of updates can scroll

v2.1 2012-08-05
	change hddList to list of lists instead of a list of strings that are split

v2.0 2012-06-23
	change output for reading by lua script instead of by ${execpi}
"""

import time
from subprocess import Popen, PIPE
import os

outputFile = ""
#### List Drives ####
hddList = [
	["UUID","mount_path"]
	]
#### End List of Drives ####
'''
hddtempOutput_lua = {'drive_label','full_path','/dev/sdX','drive_temp'}
'''
while True:
	timeStart = time.time()
	#####
	luaBarsLogData = ""
	(driveList, stderr) = Popen(["ls","-lF","/dev/disk/by-uuid"], stdout=PIPE).communicate()
	#print driveList
	##### hardcode system drives ####
	rootUUID = ""
	findRoot = driveList.find(rootUUID)
	rootName = driveList[(findRoot + len(rootUUID) + len(" -> ../../")):(findRoot + len(rootUUID) + len(" -> ../../") + 4)]
	hddtempOutput_lua = "return { {'/','/','/dev/" + rootName + "','    '}"
	####
	dataUUID = ""
	findData = driveList.find(dataUUID)
	DataName = driveList[(findData + len(dataUUID) + len(" -> ../../")):(findData + len(dataUUID) + len(" -> ../../") + 4)]
	(LData_temp, stderr) = Popen(["hddtemp","-n",("SATA:/dev/" + DataName[0:(len(DataName)-1)])], stdout=PIPE).communicate()
	homeUUID = ""
	findHome = driveList.find(homeUUID)
	HomeName = driveList[(findHome + len(homeUUID) + len(" -> ../../")):(findHome + len(homeUUID) + len(" -> ../../") + 4)]
	hddtempOutput_lua += " , {'/home','/home','/dev/" + HomeName + "'," + LData_temp.strip() + "}"
	hddtempOutput_lua += " , {'Linux_Data','/media/Linux_Data','/dev/" + DataName + "'," + LData_temp.strip() + "}"
	##### Check For Removable Drives
	for driveID in hddList:
		if os.path.exists("/dev/disk/by-uuid/" + driveID[0]) and os.path.exists(driveID[1]): ## if attached and mounted
			findData = driveList.find(driveID[0])
			DataName = driveList[(findData + len(driveID[0]) + len(" -> ../../")):(findData + len(driveID[0]) + len(" -> ../../") + 4)]
			(LData_temp, stderr) = Popen(["hddtemp","-n",("SATA:/dev/" + DataName[0:(len(DataName)-1)])], stdout=PIPE).communicate()
			driveName = driveID[1].split("/")[-1]
			hddtempOutput_lua += " , {'" + driveName + "','" + driveID[1] + "','/dev/" + DataName + "'," + LData_temp.strip() + "}"
		#endif
	#endfor
	logf = open(outputFile, 'w') # write hddataOutput to a file to 
	logf.write(hddtempOutput_lua + " }")
	logf.close()
	timeEnd = time.time()
	timeDiff = timeEnd - timeStart
	#print timeDiff
	if (timeDiff) < 1 and timeDiff > 0:
		time.sleep(1 - timeDiff)
	#endif
	#time.sleep(1)
#endwhile
